<?php

if (!defined('IN_AJAX')) die(basename(__FILE__));

global $lang, $bb_cfg, $userdata;

if (!isset($this->request['mode']))
{
	$this->ajax_die($lang['SELECT_A_MODE']);
}
$blog = new Blog();
if (isset($this->request['id']))
{
	$id = (int) $this->request['id'];
	$post = DB()->fetch_row("SELECT b.blog_cat_id as category_id, b.*, c.*, r.*, rt.blog_reply_text
		FROM ". BB_BLOG_TOPICS ." b, ". BB_BLOG_CAT ." c, ". BB_BLOG_REPLEY ." r, ". BB_BLOG_REPLEY_TEXT ." rt
		WHERE r.blog_reply_id = $id
			AND b.blog_id = r.blog_id
			AND c.blog_cat_id IN(b.blog_cat_id)
			AND r.blog_reply_id  = rt.blog_reply_id
		LIMIT 1");
	if(!$post) $this->ajax_die('not pm');
	$is_auth = $blog->auth(AUTH_ALL, $post['blog_cat_id'], $userdata, $post);

}else{
	$this->ajax_die($lang['SELECT_A_ID']);
}

if (!defined('WORD_LIST_OBTAINED'))
{
	$orig_word = array();
	$replace_word = array();
	obtain_word_list($orig_word, $replace_word);
	define('WORD_LIST_OBTAINED', true);
}

switch($this->request['mode'])
{
	case 'delete':
		if($post['blog_reply_id'] != $post['blog_first_post_id'] && ($is_auth['blog_cat_auth_mod'] || ($userdata['user_id'] == $post['blog_reply_user_id'] && $is_auth['blog_cat_auth_delete'] && $post['blog_last_post_id'] == $post['blog_reply_id'] && $post['blog_reply_time'] + 3600*3 > TIMENOW)))
		{
			$blog->delete_reply($id);			
			$this->response['hide']		= true;
			$this->response['info'] 	= $lang['REPORT_DELETED'];
			$this->response['id'] 		= $id;
		}else{
			$this->ajax_die(sprintf($lang['DELETE_OWN_POSTS'], strip_tags($is_auth['blog_cat_auth_delete_type'])));
		}

	break;
	
	case 'delete_blog':
		if($post['blog_reply_id'] != $post['blog_first_post_id'] && ($is_auth['blog_cat_auth_mod'] || ($userdata['user_id'] == $post['blog_reply_user_id'] && $is_auth['blog_cat_auth_delete'] && $post['blog_last_post_id'] == $post['blog_reply_id'] && $post['blog_reply_time'] + 3600*3 > TIMENOW)))
		{
			$blog->delete_blog($id);			
			$this->response['info'] 	= $lang['BLOG_DELETED'];
			$this->response['id'] 		= $id;
		}else{
			$this->ajax_die(sprintf($lang['DELETE_OWN_POSTS'], strip_tags($is_auth['blog_cat_auth_delete_type'])));
		}

	break;
	
	case 'reply';
		if(bf($userdata['user_opt'], 'user_opt', 'allow_post'))
		{
			$this->ajax_die($lang['RULES_REPLY_CANNOT']);
		}
        else if(!$is_auth['blog_cat_auth_reply'])
		{
			$this->ajax_die(sprintf($lang['SORRY_AUTH_REPLY'], strip_tags($is_auth['blog_cat_auth_reply_type'])));
		}

		// Use trim to get rid of spaces placed there by MS-SQL 2000
		$quote_username = (trim($post['blog_reply_user_name']) != 0) ? $post['blog_reply_user_name'] : get_username($post['blog_reply_user_id']);
		$message = "[quote=\"". $quote_username ."\"]". $post['blog_reply_text'] ."[/quote]\n";
		// hide user passkey
		$message = preg_replace('#(?<=\?uk=)[a-zA-Z0-9]{10}(?=&)#', 'passkey', $message);
		// hide sid
		$message = preg_replace('#(?<=[\?&;]sid=)[a-zA-Z0-9]{12}#', 'sid', $message);

		if (!empty($orig_word))
		{
			$message = (!empty($message)) ? preg_replace($orig_word, $replace_word, $message) : '';
		}

		if($post['blog_reply_id'] == $post['blog_first_post_id'])
		{
		    $message = "[quote]". $post['blog_title'] ."[/quote]\n";
		}

		$this->response['quote']   = true;
		$this->response['message'] = $message;
		break;

	case 'edit':
    case 'editor':
        if ($post['blog_reply_user_id'] != $userdata['user_id'] && !$is_auth['blog_cat_auth_mod'])
		{
			$this->ajax_die($lang['EDIT_OWN_POSTS']);
		}
		if($this->request['mode'] == 'editor')
		{
			$text = (string) $this->request['text'];
			$text = prepare_message($text);

			if(mb_strlen($text) > 2)
			{
				if($text != $post['blog_reply_text'])
				{
				    if($bb_cfg['max_smilies'])
				    {
						$count_smilies = substr_count(bbcode2html($text), '<img class="smile" src="'. $bb_cfg['smilies_path']);
						if($count_smilies > $bb_cfg['max_smilies'])
						{
							$this->ajax_die(sprintf($lang['MAX_SMILIES_PER_POST'], $bb_cfg['max_smilies']));
						}
				    }
					DB()->query("UPDATE ". BB_BLOG_REPLEY_TEXT ." SET blog_reply_text = '". DB()->escape($text) ."' WHERE blog_reply_id = $id LIMIT 1");
					add_search_words($id, stripslashes($text), stripslashes($post['blog_title']));
					DB()->query("DELETE FROM ". BB_BLOG_REPLEY_HTML ." WHERE blog_reply_id = ". (int) $id ." LIMIT 1");
				}
			}
			else $this->ajax_die($lang['EMPTY_MESSAGE']);

			$this->response['html'] = bbcode2html($text);
		}
		else
		{
			if ($post['blog_lock'] == TOPIC_LOCKED && !$is_auth['blog_cat_auth_mod'])
			{
				$this->ajax_die($lang['TOPIC_LOCKED']);
			}
			else if(!$is_auth['blog_cat_auth_edit'])
			{
				$this->ajax_die(sprintf($lang['SORRY_AUTH_EDIT'], strip_tags($is_auth['blog_cat_auth_edit_type'])));
			}

			$hidden_form = '<input type="hidden" name="mode" value="editpost" />';
			$hidden_form .= '<input type="hidden" name="'. POST_POST_URL .'" value="'. $id .'" />';
			$hidden_form .= '<input type="hidden" name="subject" value="'. $post['blog_title'] .'" />';

			$this->response['text'] = '
				<script type="text/javascript">
					ajax.callback.posts = function(data) {
						if(data.message_html){
							$(\'#view_mess'.$id.'\').show();
							$(\'.view-mess'.$id.'\').html(data.message_html);
							initPostBBCode(\'.view-mess'.$id.'\');
								var maxH   = screen.height - 490;
							$(\'.view-mess'.$id.'\').css({ maxHeight: maxH });
						}
					};
				</script>
				<div id="view_mess'.$id.'" class="hidden">
					<div class="tLeft view-mess'.$id.'"></div>
				</div>
			    <form action="blog.php?mode=add&b='.$id.'" method="message" name="message" id="blog-comment">
					'. $hidden_form .'
					<div class="buttons mrg_4">
						<input type="button" value="B" name="codeB" title="'.$lang['BOLD'].'" style="font-weight: bold; width: 30px;" />
						<input type="button" value="i" name="codeI" title="'.$lang['ITALIC'].'" style="width: 30px; font-style: italic;" />
						<input type="button" value="u" name="codeU" title="'.$lang['UNDERLINE'].'" style="width: 30px; text-decoration: underline;" />
						<input type="button" value="s" name="codeS" title="'.$lang['STRIKEOUT'].'" style="width: 30px; text-decoration: line-through;" />&nbsp;&nbsp;
						<input type="button" value="'.$lang['QUOTE'].'" name="codeQuote" title="'.$lang['QUOTE_TITLE'].'" style="width: 57px;" />
						<input type="button" value="Img" name="codeImg" title="'.$lang['IMG_TITLE'].'" style="width: 40px;" />
						<input type="button" value="'.$lang['URL'].'" name="codeUrl" title="'.$lang['URL_TITLE'].'" style="width: 63px; text-decoration: underline;" /><input type="hidden" name="codeUrl2" />&nbsp;
						<input type="button" value="'.$lang['CODE'].'" name="codeCode" title="'.$lang['CODE_TITLE'].'" style="width: 43px;" />
						<input type="button" value="'.$lang['LIST'].'" name="codeList" title="'.$lang['LIST_TITLE'].'" style="width: 60px;" />
						<input type="button" value="1." name="codeOpt" title="'.$lang['LIST_ITEM'].'" style="width: 30px;" />&nbsp;
						<input type="button" value="'.$lang['QUOTE_SEL'].'" name="quoteselected" title="'.$lang['QUOTE_SELECTED'].'" onmouseout="bbcode.refreshSelection(false);" onmouseover="bbcode.refreshSelection(true);" onclick="bbcode.onclickQuoteSel();" />&nbsp;
					</div>
					<textarea id="message-'. $id .'" class="editor mrg_4" name="message" cols="92" rows="10" tabindex="5">'. $post['blog_reply_text'] .'</textarea>
					<div class="mrg_4 tCenter">
						<input type="button" value="'.$lang['PREVIEW'].'" onclick="ajax.exec({ action: \'posts\', type: \'view_message\', message: $(\'textarea#message-'. $id .'\').val()});">
						<input type="button" onclick="edit_post('. $id .');" value="'. $lang['CANCEL'] .'">
						<input type="button" onclick="edit_post('. $id .', \'editor\', $(\'#message-'. $id .'\').val()); return false;" class="bold" value="'. $lang['SUBMIT'] .'">
					</div><hr>
					<script type="text/javascript">
					var bbcode = new BBCode("message-'. $id .'");
					var ctrl = "ctrl";

					bbcode.addTag("codeB", "b", null, "B", ctrl);
					bbcode.addTag("codeI", "i", null, "I", ctrl);
					bbcode.addTag("codeU", "u", null, "U", ctrl);
					bbcode.addTag("codeS", "s", null, "S", ctrl);

					bbcode.addTag("codeQuote", "quote", null, "Q", ctrl);
					bbcode.addTag("codeImg", "img", null, "R", ctrl);
					bbcode.addTag("codeUrl", "url", "/url", "", ctrl);
					bbcode.addTag("codeUrl2", "url=", "/url", "W", ctrl);

					bbcode.addTag("codeCode", "code", null, "K", ctrl);
					bbcode.addTag("codeList",  "list", null, "L", ctrl);
					bbcode.addTag("codeOpt", "*", "", "0", ctrl);
					</script>
				</form>';
		}
		$this->response['id'] = $id;
	break;
	
	default:
		$this->ajax_die($lang['SELECT_A_MODE']);
		break;
}