<?php
// ACP Header - START
if (!empty($setmodules))
{
	$module['BLOG']['BLOG_CAT'] = basename(__FILE__);
	return;
}
$gen_simple_header = true;

require('./pagestart.php');

// ACP Header - END

require(INC_DIR  .'functions_group.php');
require(INC_DIR  .'functions_blog.php');
require(LANG_DIR .'lang_admin_bt.php');

$blog = new Blog();

$forum_auth_fields = array(
	'blog_cat_auth_view',
	'blog_cat_auth_read',
	'blog_cat_auth_post',
	'blog_cat_auth_post_view',
	'blog_cat_auth_reply',
	'blog_cat_auth_edit',
	'blog_cat_auth_delete',
);

$field_names = array();
foreach ($forum_auth_fields as $auth_type)
{
	$field_names[$auth_type] = $lang[strtoupper($auth_type)];
}

$forum_auth_levels = array('ALL',   'REG',    'PRIVATE', 'MOD',    'ADMIN');
$forum_auth_const  = array(AUTH_ALL, AUTH_REG, AUTH_ACL,  AUTH_MOD, AUTH_ADMIN);

$mode = (@$_REQUEST['mode']) ? (string) $_REQUEST['mode'] : '';

$cat_forums = $blog->get_cat();

if ($orphan_sf_sql = $blog->get_orphan_sf())
{
	$blog->fix_orphan_sf($orphan_sf_sql, TRUE);
}
$forum_parent = $cat_id = 0;
$forumname = '';

if (isset($_REQUEST['addcat']) || isset($_REQUEST['addcat']))
{
	$mode = (isset($_REQUEST['addcat'])) ? "addcat" : "addcat";

	if ($mode == 'addcat' && isset($_POST['addcat']) && isset($_POST['forumname']) && is_array($_POST['addcat']))
	{
		$req_cat_id = array_keys($_POST['addcat']);
		$cat_id = $req_cat_id[0];
		$forumname = stripslashes($_POST['forumname'][$cat_id]);
	}
}

$show_main_page = false;
$dir = $bb_cfg['dir_blog_cat_icon'];

if ($mode)
{
	switch ($mode)
	{
		case 'addcat':
		case 'editcat':
			$s_column_span = 0;
			if ($mode == 'editcat')
			{

				$l_title = $lang['EDIT_FORUM'];
				$newmode = 'modcat';
				$buttonvalue = $lang['UPDATE'];

				$forum_id = intval($_GET[POST_FORUM_URL]);

				$row = $blog->get_info($forum_id);

				$forumname = $row['blog_cat_name'];
				$forumdesc = $row['blog_cat_desc'];
				$forum_status = $row['blog_cat_status'];
				$show_on_index = $row['blog_cat_show_on_index'];
				$forum_rows = $blog->get_info($forum_id);
				$blog_cat_icon = $row['blog_cat_icon'];
			}else{
				$l_title = $lang['CREATE_FORUM'];
				$newmode = 'createcat';
				$buttonvalue = $lang['CREATE_FORUM'];

				$forumdesc = '';
				$forum_status = FORUM_UNLOCKED;
				$forum_id = '';
				$show_on_index = 1;
				$blog_cat_icon = 0;
				$forum_rows = DB()->fetch_rowset("SELECT *
					FROM ".BB_BLOG_CAT);
			}
			// Forum icon
			$dir_open = @opendir($dir);
			while($file = @readdir($dir_open))
			{
				if( !preg_match('#^new_#i', $file) && !@is_dir(syte_realpath($dir . $file)) && ($file != 'folder_big.png') )
				{
					$img_size = @getimagesize($dir . $file);

					if( $img_size[0] && $img_size[1] )
					{
						$icon_images[] = $file;
					}
				}
			}
			@closedir($dir_open);

            $icon_selected = ( isset($blog_cat_icon) ) ? '' : HTML_SELECTED;
			$icon_select = "<select name=\"blog_cat_icon\" onChange=\"document.images['blog_cat_icon_img'].src = '". $dir ."' + this.value;\" >";
			$icon_select .= '<option value="0">' . $lang['SELECT_ICON'] . '</option>';
			for( $i = 0; $i < count($icon_images); $i++ )
			{
				if( $icon_images[$i] == $blog_cat_icon )
				{
					$icon_selected = HTML_SELECTED;
                    $icon_edit_img = $icon_images[$i];
				}
				else
				{
					$icon_selected = '';
					$icon_edit_img = 'folder_big.png';
				}

				$icon_select .= '<option value="'. $icon_images[$i] .'"'. $icon_selected .'>'. $icon_images[$i] .'</option>';
			}
			$icon_select .= '</select>';
			// Forum icon [END]
				for($j = 0; $j < count($forum_auth_fields); $j++)
				{
					$custom_auth[$j] = '&nbsp;<select name="' . $forum_auth_fields[$j] . '">';
					$custom_auth[$j] .= '<optgroup label="&nbsp;'. $field_names[$forum_auth_fields[$j]] .'">';

					for($k = 0; $k < count($forum_auth_levels); $k++)
					{
						$selected = ($mode == 'editcat' && ($forum_rows[$forum_auth_fields[$j]] == $forum_auth_const[$k])) ? ' selected="selected"' : '';
						$custom_auth[$j] .= '<option value="' . $forum_auth_const[$k] . '"' . $selected . '>' . $lang['FORUM_' . strtoupper($forum_auth_levels[$k])] . '</OPTION>';
					}
					$custom_auth[$j] .= '</optgroup>';
					$custom_auth[$j] .= '</select>&nbsp;';

					$template->assign_block_vars('forum_auth', array(
						'S_AUTH_LEVELS_SELECT' => $custom_auth[$j],
					));

					$s_column_span++;
				}

			$forumlocked = $forumunlocked = '';

			$forum_status == ( FORUM_LOCKED ) ? $forumlocked = "selected=\"selected\"" : $forumunlocked = "selected=\"selected\"";

			// These two options ($lang['STATUS_UNLOCKED'] and $lang['STATUS_LOCKED']) seem to be missing from
			// the language files.
			$lang['STATUS_UNLOCKED'] = isset($lang['STATUS_UNLOCKED']) ? $lang['STATUS_UNLOCKED'] : 'Unlocked';
			$lang['STATUS_LOCKED'] = isset($lang['STATUS_LOCKED']) ? $lang['STATUS_LOCKED'] : 'Locked';

			$statuslist = "<option value=\"" . FORUM_UNLOCKED . "\" $forumunlocked>" . $lang['STATUS_UNLOCKED'] . "</option>\n";
			$statuslist .= "<option value=\"" . FORUM_LOCKED . "\" $forumlocked>" . $lang['STATUS_LOCKED'] . "</option>\n";

			$s_hidden_fields = '<input type="hidden" name="mode" value="' . $newmode .'" /><input type="hidden" name="' . POST_FORUM_URL . '" value="' . $forum_id . '" />';
			
			$template->assign_vars(array(
				'TPL_EDIT_FORUM' => true,

				'S_FORUM_ACTION' => 'admin_blog_category.php',
				'S_HIDDEN_FIELDS' => $s_hidden_fields,
				'S_SUBMIT_VALUE' => $buttonvalue,
				'S_STATUS_LIST' => $statuslist,

				'SHOW_ON_INDEX' => $show_on_index,

				'L_FORUM_TITLE' => $l_title,

				'FORUM_NAME' => htmlCHR($forumname),
				'DESCRIPTION' => htmlCHR($forumdesc),
				'ICON_SELECT' => $icon_select,
				'ICON_IMG'       => $dir . $icon_edit_img,
			));
			break;

		case 'createcat':
			//
			// Create a forum in the DB
			//
			$forum_name = DB()->escape(trim($_POST['forumname']));
			$forum_status = intval($_POST['forumstatus']);
			$forum_desc = DB()->escape(trim($_POST['forumdesc']));
			$blog_cat_icon = addslashes(trim($_POST['blog_cat_icon']));
			
			$show_on_index = intval($_POST['show_on_index']);

			if (!$forum_name)
			{
				message_die(GENERAL_ERROR, "Can't create a forum without a name");
			}


			// Default permissions of public forum
			$field_sql = $value_sql = '';

			for($i = 0; $i < count($forum_auth_fields); $i++)
			{
				$value = intval($_POST[$forum_auth_fields[$i]]);

				if ( $forum_auth_fields[$i] == 'auth_vote' )
				{
					if ( $_POST['auth_vote'] == AUTH_ALL )
					{
						$value = AUTH_REG;
					}
				}

				$field_sql .= ( ( $field_sql != '' ) ? ', ' : '' ) .$forum_auth_fields[$i];
				$value_sql .= ( ( $value_sql != '' ) ? ', ' : '' ) .$value;
			}

			$columns = ' blog_cat_name, blog_cat_desc, blog_cat_status, blog_cat_show_on_index, blog_cat_icon, '. $field_sql;
			$values = "'$forum_name', '$forum_desc', $forum_status, $show_on_index, '$blog_cat_icon', ". $value_sql;

			DB()->query("INSERT INTO ". BB_BLOG_CAT ." ($columns) VALUES ($values)");

			$datastore->update('blog_cat_forums');

			$message = $lang['FORUMS_UPDATED'] . "<br /><br />" . sprintf($lang['CLICK_RETURN_FORUMADMIN'], "<a href=\"" . "admin_blog_category.php?c=$cat_id" . "\">", "</a>") . "<br /><br />" . sprintf($lang['CLICK_RETURN_ADMIN_INDEX'], "<a href=\"index.php?pane=right\">", "</a>");
			message_die(GENERAL_MESSAGE, $message);

			break;

		case 'modcat':
			//
			// Modify a forum in the DB
			//
			$forum_id = intval($_POST[POST_FORUM_URL]);
			$forum_name = DB()->escape(trim($_POST['forumname']));
			$forum_desc = DB()->escape(trim($_POST['forumdesc']));
			$forum_status = intval($_POST['forumstatus']);
			$blog_cat_icon = addslashes(trim($_POST['blog_cat_icon']));

			$show_on_index = intval($_POST['show_on_index']);

			if (!$forum_name)
			{
				message_die(GENERAL_ERROR, "Can't modify a forum without a name");
			}
			$sql_autch = '';
			for($i = 0; $i < count($forum_auth_fields); $i++)
			{
				$value = intval($_POST[$forum_auth_fields[$i]]);

				if ( $forum_auth_fields[$i] == 'auth_vote' )
				{
					if ( $_POST['auth_vote'] == AUTH_ALL )
					{
						$value = AUTH_REG;
					}
				}

				$sql_autch .= ( ( $sql_autch != '' ) ? ', ' : '' ) .$forum_auth_fields[$i] . ' = ' . $value;
			}


			DB()->query("
				UPDATE ". BB_BLOG_CAT ." SET
					blog_cat_name			= '$forum_name',
					blog_cat_desc			= '$forum_desc',
					blog_cat_status			= $forum_status,
					blog_cat_show_on_index	= $show_on_index,
					blog_cat_icon			= '$blog_cat_icon',
					$sql_autch
				WHERE blog_cat_id			= $forum_id
			");


			//$datastore->update('cat_forums');

			$message = $lang['FORUMS_UPDATED'] . "<br /><br />";
			$message .= sprintf($lang['CLICK_RETURN_FORUMADMIN'], "<a href=\"" . "admin_blog_category.php?c=$cat_id" . "\">", "</a>") . "<br /><br />" . sprintf($lang['CLICK_RETURN_ADMIN_INDEX'], "<a href=\"index.php?pane=right\">", "</a>");
			message_die(GENERAL_MESSAGE, $message);

			break;


		case 'deletecat':
			//
			// Show form to delete a forum
			//
			$forum_id = (int) $_GET['f'];

			if($forum_id)
			{
				$sql = "DELETE FROM " . BB_BLOG_CAT . "
					WHERE blog_cat_id = $forum_id";
			
				if( !$result = DB()->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, "Couldn't delete blog data", "", __LINE__, __FILE__, $sql);
				}
				$datastore->update('blog_cat_forums');

				$message = 'Категория удалена' . "<br /><br />" . sprintf('Нажмите сюда для перехода к управлению категориями', "<a href=\"admin_blog_category.php\">", "</a>") . "<br /><br />" . sprintf($lang['CLICK_RETURN_ADMIN_INDEX'], '<a href="index.php?pane=right">', '</a>');

				message_die(GENERAL_MESSAGE, $message);

			}
			else
			{
				message_die(GENERAL_MESSAGE, 'Категория не была выбрана');
			}

			break;

		case 'cat_order':
			$forum_id = intval($_GET[POST_FORUM_URL]);

			$move = intval($_GET['move']);
			if($move > 0)
			{
				$sql = "UPDATE " . BB_BLOG_CAT . "
					SET blog_cat_order = blog_cat_order + $move
					WHERE blog_cat_id = $forum_id";
				if( !$result = DB()->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, "Couldn't change blog category order", "", __LINE__, __FILE__, $sql);
				}

				renumber_blog_order('category');
				$datastore->update('blog_cat_forums');
				$show_main_page = TRUE;
			}else{
				bb_die('Куда выше то?!?!?!');
			}	
			
			break;

		default:
			message_die(GENERAL_MESSAGE, $lang['NO_MODE']);

			break;
	}
}

if (!$mode || $show_main_page)
{
	$template->assign_vars(array(
		'TPL_FORUMS_LIST' => true,

		'S_FORUM_ACTION' => "admin_blog_category.php",
		'L_FORUM_TITLE' => $lang['FORUM_ADMIN_MAIN']
	));

	$sql = DB()->fetch_rowset("SELECT *
		FROM " . BB_BLOG_CAT . "
		ORDER BY blog_cat_order");
		
	$i = 0;

	if(count($sql)>0)
	{
		$gen_cat = array();

		$bgr_class_1    = 'row1';
		$bgr_class_2    = 'row2';
		$bgr_class_over = 'row3';

			foreach($sql as $rows)
			{
				$cat_id = $rows['blog_cat_id'];
				$i++;
				$bgr_class = (!($i % 2)) ? $bgr_class_2 : $bgr_class_1;
				$row_bgr   = " class=\"$bgr_class\" onmouseover=\"this.className='$bgr_class_over';\" onmouseout=\"this.className='$bgr_class';\"";

					$template->assign_block_vars("catrow",	array(
						'FORUM_NAME' => htmlCHR($rows['blog_cat_name']),
						'FORUM_DESC' => htmlCHR($rows['blog_cat_desc']),
						'NUM_TOPICS' => $rows['blog_cat_topics'],
						'NUM_POSTS'  => $rows['blog_cat_posts'],
						'FORUM_ICON' => ($rows['blog_cat_icon']) ? $dir . $rows['blog_cat_icon'] : $dir . 'folder_big.png',

						'FORUM_ID' => $rows['blog_cat_id'],
						'ROW_BGR'  => $row_bgr,

						'SHOW_ON_INDEX'     => (bool) $rows['blog_cat_show_on_index'],
						'U_VIEWFORUM'       => BB_ROOT ."viewforum.php?f=$cat_id",
						'U_FORUM_EDIT'      => "admin_blog_category.php?mode=editcat&amp;f=$cat_id",
						'U_FORUM_DELETE'    => "admin_blog_category.php?mode=deletecat&amp;f=$cat_id",
						'U_FORUM_MOVE_UP'   => "admin_blog_category.php?mode=cat_order&amp;move=-15&amp;f=$cat_id",
						'U_FORUM_MOVE_DOWN' => "admin_blog_category.php?mode=cat_order&amp;move=15&amp;f=$cat_id",
					));
			}
	}
}

print_page('admin_blog_category.tpl', 'admin');
