<?php
define('IN_PHPBB', true);
define('BB_ROOT', './');
require(BB_ROOT ."common.php");
require(INC_DIR .'bbcode.php');
require(INC_DIR .'functions_post.php');
include(INC_DIR .'functions_blog.php');

$mode = htmlspecialchars(request_var('mode', ''));
/*print_r($_POST);
print_r("<br />");
print_r(int_check($_POST['category'], true));
print_r("<br />");
print_r(implode(',',$_POST['category']));*/
if ($mode == 'smilies')
{
	generate_smilies('window');
	exit;
}

$delete = (bool) @$_REQUEST['delete'];

$user->session_start();
$blog = new Blog();

$errors = array();
$is_auth = array();

$blog_postid = isset($_GET[BLOG_TOPIC_URL]) ? intval($_GET[BLOG_TOPIC_URL]):'';

if (IS_GUEST)
{
	switch ($mode)
	{
		case 'add':
			$redirect = "mode=add";
			break;
		case 'update':
		case 'edit':
		case 'editnews':
			$redirect = "mode=edit&b=$blog_postid";
			break;
		case 'delete':
			$redirect = "mode=delete&b=$blog_postid";
			break;
		default:
			$redirect = '';
	}
	redirect("login.php?redirect=/blog_newsadd.php?$redirect");
}

switch ($mode)
{
	case "add" :
	case "edit" :
		if ($mode == 'edit')
		{
			if(bf($userdata['user_opt'], 'user_opt', 'allow_post_edit'))
			{
				bb_die($lang['RULES_EDIT_CANNOT']);
			}
			$forum_rows = DB()-> fetch_row("
					SELECT top.*,tag.*,prev.*,text.*
					FROM ".BB_BLOG_TOPICS." AS top, ".BB_BLOG_TAG." AS tag, ".BB_BLOG_TOPICS_PREV." AS prev, ".BB_BLOG_TOPICS_TEXT." AS text
					WHERE top.blog_id = $blog_postid
						AND tag.blog_topics_id = top.blog_id
						AND prev.blog_topics_id = top.blog_id
						AND text.blog_topics_id = top.blog_id
				");
			$is_auth = $blog->auth(AUTH_ALL, $forum_rows['blog_cat_id'], $userdata, $forum_rows);
			$is_auth_type = 'auth_edit';
			if ($forum_rows['blog_autor'] != $userdata['user_id'] && !IS_ADMIN && !$is_auth['auth_mod'])
			{
				$message = ($delete || $mode == 'delete') ? $lang['DELETE_OWN_POSTS'] : $lang['EDIT_OWN_POSTS'];
				$message .= '<br /><br />'. sprintf($lang['CLICK_RETURN_TOPIC'], '<a href="'. TOPIC_URL ."$blog_postid" .'">', '</a>');

				message_die(GENERAL_MESSAGE, $message);
			}
			$cat_id 	= $forum_rows['blog_cat_id'];
			$title		= $forum_rows['blog_title'];
			$lock		= $forum_rows['blog_lock'];
			$dost		= $forum_rows['blog_dost'];
			$message	= $forum_rows['blog_topics_text'];
			$tag		= $forum_rows['blog_tag'];
			$preview	= $forum_rows['blog_topics_prev'];
			$image 		= $forum_rows['blog_topics_img'];
			$active 	= (!empty($lock)) ? "checked=\"checked\"" : "";
			$not_active = (empty($lock)) ? "checked=\"checked\"" : "";
			
			$mode_sel = "blog_newsadd.php?mode=update&b=$blog_postid";
		}else{
			if(bf($userdata['user_opt'], 'user_opt', 'allow_topic'))
			{
				bb_die($lang['RULES_POST_CANNOT']);
			}
			$cat_id 	= isset($_POST['category']) ? $_POST['category'] : '';
			$title		= isset($_POST['title']) ? clean_title($_POST['title']) : '';
			$lock		= isset($_POST['lock']) ? (int) $_POST['lock'] : '';
			$dost		= isset($_POST['dost']) ? (int) $_POST['dost'] : '';
			$message	= isset($_POST['message']) ? prepare_message($_POST['message']) : '';
			$tag		= isset($_POST['tag']) ? htmlCHR($_POST['tag']) : '';
			$preview	= isset($_POST['preview']) ? htmlCHR($_POST['preview']) : '';
			$image 		= isset($_POST['image']) ? $_POST['image'] : '';
			if(!empty($cat_id))
			{
				if(!int_check($cat_id, true))
				{
					$errors[] = 'Не корректно';
				}	
			}else{
				$errors[] = 'Вы не выбрали категорию';
			}
			if(empty($title))
			{
				$errors[] = 'Вы не ввели тему';
			}
			if(empty($preview))
			{
				$errors[] = 'Введите описание новости';
			}
			if(isset($lock))
			{
				if(!int_check($lock))
				{
					$errors[] = 'Не корректно';
				}
			}else{
				$errors[] = 'Вы не выбрали вид темы';
			}
			if(isset($dost))
			{
				if(!int_check($dost))
				{
					$errors[] = 'Не корректно';
				}
			}else{
				$errors[] = 'Вы не выбрали права доступа к новости';
			}
			if(empty($_POST['message']))
			{
				$errors[] = 'Введите текст';
			}
			$active = (!empty($lock)) ? "checked=\"checked\"" : "";
			$not_active = (empty($lock)) ? "checked=\"checked\"" : "";
		
			if (int_check($cat_id, true) && $title && int_check($lock) && int_check($dost) && $message && $preview) 
			{
				$blog->add_topic(array(
					'cat_id'	=> implode(',',$cat_id),
					'title'		=> $title,
					'lock'		=> $lock,
					'dost'		=> $dost,
					'text'		=> $message,
					'tag'		=> $tag,
					'prev'		=> $preview,
					'img'		=> $image,
				));
			}
			$mode_sel = "blog_newsadd.php?mode=add";	
		}
	break;
	
	case "editnews" :
		$mode_sel = "blog_newsadd.php?mode=update";
	
	break;
	
	case "delete" :
		if (!$post_data['last_post'] && !$is_auth['auth_mod'] && ($mode == 'delete' || $delete))
		{
			message_die(GENERAL_MESSAGE, $lang['CANNOT_DELETE_REPLIED']);
		}
		$mode_sel = "blog_newsadd.php?mode=delete";
	
	break;
	
	case "update" :

		$cat_id 	= isset($_POST['category']) ? $_POST['category'] : '';
		$title		= isset($_POST['title']) ? clean_title($_POST['title']) : '';
		$lock		= isset($_POST['lock']) ? (int) $_POST['lock'] : '';
		$dost		= isset($_POST['dost']) ? (int) $_POST['dost'] : '';
		$message	= isset($_POST['message']) ? prepare_message($_POST['message']) : '';
		$tag		= isset($_POST['tag']) ? htmlCHR($_POST['tag']) : '';
		$preview	= isset($_POST['preview']) ? htmlCHR($_POST['preview']) : '';
		$image 		= isset($_POST['image']) ? $_POST['image'] : '';
		if(!empty($cat_id))
		{
			if(!int_check($cat_id, true))
			{
				$errors[] = 'Не корректно';
			}	
		}else{
			$errors[] = 'Вы не выбрали категорию';
		}
		if(empty($title))
		{
			$errors[] = 'Вы не ввели тему';
		}
		if(empty($preview))
		{
			$errors[] = 'Введите описание новости';
		}
		if(isset($lock))
		{
			if(!int_check($lock))
			{
				$errors[] = 'Не корректно';
			}
		}else{
			$errors[] = 'Вы не выбрали вид темы';
		}
		if(isset($dost))
		{
			if(!int_check($dost))
			{
				$errors[] = 'Не корректно';
			}
		}else{
			$errors[] = 'Вы не выбрали права доступа к новости';
		}
		if(empty($_POST['message']))
		{
			$errors[] = 'Введите текст';
		}
		$active = (!empty($lock)) ? "checked=\"checked\"" : "";
		$not_active = (empty($lock)) ? "checked=\"checked\"" : "";
	
		if (int_check($cat_id, true) && $title && int_check($lock) && int_check($dost) && $message && $preview) 
		{
			$blog->add_topic(array(
				'blog_id'	=> $blog_postid,
				'cat_id'	=> implode(',',$cat_id),
				'title'		=> $title,
				'lock'		=> $lock,
				'dost'		=> $dost,
				'text'		=> $message,
				'tag'		=> $tag,
				'prev'		=> $preview,
				'img'		=> $image,
			),'edit');
		}
		$mode_sel = "blog_newsadd.php?mode=update";
	break;
	
	default:
		$cat_id = $title = $lock = $dost = $message = $tag = $preview = $image = '';
		$active = "";
		$not_active = "checked=\"checked\"";
		$mode_sel = "blog_newsadd.php?mode=add";
}

$forum_auth_levels = array('ALL',   'REG',    'PRIVATE', 'MOD',    'ADMIN');
$forum_auth_const  = array(AUTH_ALL, AUTH_REG, AUTH_ACL,  AUTH_MOD, AUTH_ADMIN);
$custom_auth = '&nbsp;<select name="dost">';
$forum_auth_dost = isset($dost)? $dost: 1;
for($k = 0; $k < count($forum_auth_levels); $k++)
{
	$selected = ($forum_auth_const[$k] == $forum_auth_dost) ? ' selected' : '';
	$custom_auth .= '<option value="' . $forum_auth_const[$k] . '"' . $selected . '>' . $lang['FORUM_' . strtoupper($forum_auth_levels[$k])] . '</option>';
}
$custom_auth .= '</select>&nbsp;';

$template->assign_block_vars('auth', array(
	'S_AUTH_LEVELS_SELECT' => $custom_auth,
));

generate_smilies('inline');
$max_blog_name_len	= 30;
$max_blog_rows		= 25;
$max_cat_selected	= 10;


$db_fields_bool = array(
	'blog_cat_status'            => 0,  
);
$excluded_forums_csv = $user->get_excluded_blog(AUTH_VIEW);

$where_sql = ($excluded_forums_csv) ? "
	WHERE blog_cat_id NOT IN($excluded_forums_csv)
" : '';


$sql = 'SELECT blog_cat_id, blog_cat_name
	FROM '. BB_BLOG_CAT ."
		$where_sql
	ORDER BY blog_cat_order, blog_cat_id";

if (!$result = DB()->sql_query($sql))
{
	message_die(GENERAL_ERROR, "Couldn't get list of Categories".$excluded_forums_csv."", "", __LINE__, __FILE__, $sql);
}

$rowset = DB()->sql_fetchrowset($result);
$forum_rows = min($max_blog_rows, count($rowset));

$opt = '';
$search_in_forums_fary = array();
if (!empty($cat_id))
{
	switch ($mode)
	{
		case "add" :
			$categoryArr = $_POST['category'];
		break;
		
		case "edit" :
			$categoryArr = explode(',',$cat_id);
		break;
		
		default:
	}
	if(int_check($categoryArr, true))
	{
		foreach ($rowset as $c_data_id)
		{
			$allowed_cat[] = $c_data_id['blog_cat_id'];
		}
		$categoryArr = (array) $categoryArr;
		array_deep($categoryArr, 'intval');
		$valid_forums = array_intersect($categoryArr, $allowed_cat);
		$cat_val = join(',', $valid_forums);
	}
	if ($cat_val)
	{
		$search_in_cat_ary  = array_slice(explode(',', $cat_val), 0, $max_cat_selected);
		$search_in_cat_fary = array_flip($search_in_cat_ary);
	}
}

foreach ($rowset as $c_data)
{
	//$opt .= '<optgroup label="&nbsp;'. $c_data['blog_section_name'] ."\">\n";
		$blog_cat_name = $c_data['blog_cat_name'];
		$blog_cat_name = str_short($blog_cat_name, $max_blog_name_len);
		$selected = (isset($search_in_cat_fary[$c_data['blog_cat_id']])) ? HTML_SELECTED : '';
		$opt .= '<option id="'. $c_data['blog_cat_id'] .'" value="'. $c_data['blog_cat_id'] .'"'. $selected .'>'. $blog_cat_name ."&nbsp;</option>\n";
	//$opt .= "</optgroup>\n";
}

$catSelect = "\n".'<select class="textCtrl" style="width: 100%;" name="category[]" multiple="multiple" size="'. $forum_rows ."\">\n". $opt ."</select>\n";


$template->assign_vars(array(
	'PAGE_TITLE'        => $lang['BLOG_CREATING_ARTICLE'],
	'ADD_CAT_ID'		=> $cat_id,
	'ADD_TITLE'			=> $title,
	'ADD_LOCK'			=> $lock,
	'ADD_DOST'			=> $dost,
	'MESSAGE'			=> $message,
	'ADD_TAG'			=> $tag,
	'ADD_PREVIEW'		=> $preview,
	'ADD_IMAGE'			=> $image,
    'MODE'				=> $mode_sel,
	'ACTIVE'			=> $active,
	'NOT_ACTIVE'		=> $not_active,
	'U_SMILIES' 		=> "blog_newsadd.php?mode=smilies",
	'ERROR_MESSAGE'		=> ($errors) ? '<ul type="circle">'. implode_wrap('<li>', '</li>', array_unique($errors)) . '</ul>' : '',
	'S_BLOG_CAT_STATUS'	=> $catSelect,
	'MAX_SELECT_CAT'	=> $max_cat_selected,
	'ON_MORE_URL'	    => true,
	'QUESTS_REPLY'	    => true,
	'TITLE_MORE_URL'	=> sprintf($lang['BLOG_INDEX'], $bb_cfg['sitename']),
	'U_MORE_URL'	    => make_url("blog.php", true),
));

print_page('blog_newsadd.tpl');
