<script type="text/javascript" src="{SITE_URL}misc/js/validate.js"></script>
<script type="text/javascript">
    $(document).ready(function()
    {
		$("textarea[maxlength]").limitTextArea();
		$("input[maxlength]").limitTextArea();
	});
</script>
<script type="text/javascript">
$(document).ready(function() {
	$("#FormBlogAdedNews").validate({
		rules: {
			title: {
				required: true,
				minlength: 10,
				maxlength: 200,
			},
			image: {
				url: true,
				minlength: 10,
				maxlength: 250,						
			},
			preview: {
				required: true,
				minlength: 50,
				maxlength: 400,
			},
			tag: {
				maxlength: 200,
			},
			"category[]": {
				required: true,
				rangelength:[1,10]
			},
		},
		messages: {
			title: {
				required: "Введите название статьи",
				minlength: jQuery.format("Минимальное количество символов {0} ."),
				maxlength: jQuery.format("Максимальное количество символов {0} ."),
			},
			image: {
				required: "Введите URL до изображения",
				url: "Введите корректный URL до изображения",
				minlength: jQuery.format("Минимальное количество символов {0} ."),
				maxlength: jQuery.format("Максимальное количество символов {0} ."),
			},
			preview: {
				required: "Введите текст для превью",
				minlength: jQuery.format("Минимальное количество символов {0} ."),
				maxlength: jQuery.format("Максимальное количество символов {0} ."),
			},
			tag: {
				maxlength: jQuery.format("Максимальное количество символов {0} ."),
			},
			"category[]": {
				required: "Выберитетекст категорию",
				rangelength: jQuery.format("Пожалуйста, выберите значение от {0} до {1} ."),
			},
		}
	});
});

jQuery.validator.addMethod(
	"selectNone",
	function(value, element) {
		if (element.value == "none")
		{
			return false;
		}
		else return true;
	},
	"Please select an option."
);

</script>
<br />
<form id="FormBlogAdedNews" action="{MODE}" method="post" name="post">
<table class="bordered">
<col class="row1">
<col class="row2">

<tbody class="pad_4">
<tr>
	<th colspan="3" class="thHead"><b>{POSTING_TYPE_TITLE}</b></th>
</tr>
<tr id="view_message" class="hidden">
	<td colspan="2">
	    <div class="view-message"></div>
	</td>
</tr>
</tbody>
<tr> 
	<td class="row1 vTop pad_4" valign="top">
		<p><b>Категории</b></p>
	</td>
	<td>
	<div class="clearfix">
		{S_BLOG_CAT_STATUS}
		<div class="pad_8">
			<div align="center" class="notice">Выберите категории. Для выбора нескольких категорий, <b>зажмите Ctrl</b> ( <b>максимально</b> доступное количество для выбора : <b>{MAX_SELECT_CAT}</b> категорий).</div>
		</div>
	</div>	
	</td>
</tr>
<tr>
	<td class="row1 vTop pad_4" valign="top">
		<p><b>{L_SUBJECT}</b></p>
	</td>
    <td><input type="text" name="title" class="textCtrl" placeholder="Введите Название вашей статьи..." value="{ADD_TITLE}" id="maxlength type-title" maxlength="200" /></td>
</tr>
<tr>
	<td class="row1 vTop pad_4" valign="top">
		<p><b>Описание</b></p>
	</td>
	<td>
		<table class="bordered w100" cellpadding="0" border=0>
			<tr>
				<td>
					<p><b>Изображение</b></p>
				</td>
				<td>
					<input type="text" name="image" value="{ADD_IMAGE}" class="textCtrl" placeholder="Введите URL Изображения, отображаемого в Описании статьи..." id="maxlength type-image" maxlength="400"/>
				</td>
			</tr>
			<tr>
				<td>
					<p><b>Текст</b></p>
				</td>
				<td>
					<textarea class="textCtrl" name="preview" rows="8" cols="92" placeholder="Введите Текст Описания..." id="maxlength type-preview" maxlength="400" >{ADD_PREVIEW}</textarea>
				</td>
			</tr>
		</table>
	</td>
</tr>

<tr>
	<td class="vTop pad_4">
		<p><b>Содержание</b></p>

		<table id="smilies" class="smilies borderless mrg_16">
		<!-- BEGIN smilies_row -->
		<tr>
			<!-- BEGIN smilies_col -->
			<td><a href="#" onclick="bbcode && bbcode.emoticon('{smilies_row.smilies_col.SMILEY_CODE}'); return false;"><img src="{smilies_row.smilies_col.SMILEY_IMG}" alt="" title="{smilies_row.smilies_col.SMILEY_DESC}" /></a></td>
			<!-- END smilies_col -->
		</tr>
		<!-- END smilies_row -->
		<!-- BEGIN switch_smilies_extra -->
		<tr>
			<td colspan="{S_SMILIES_COLSPAN}"><a href="{U_SMILIES}" onclick="window.open('{U_SMILIES}', '_smilies', 'HEIGHT=420,resizable=yes,scrollbars=yes,WIDTH=470'); return false;" target="_smilies" class="med">{L_MORE_EMOTICONS}</a></td>
		</tr>
		<!-- END switch_smilies_extra -->
		</table><!--/smilies-->

 </td>
 <td class="vTop pad_0 w100"><!-- INCLUDE posting_editor.tpl --></td>
</tr>
<tr>
	<td class="row1 vTop pad_4" valign="top">
		<p><b>Теги</b></p>
	</td>
    <td>
		<input type="text" name="tag" value="{ADD_TAG}" class="textCtrl" placeholder="Введите Теги статьи..." id="maxlength type-tag" maxlength="200"/>
		<div class="pad_4">
			<div align="center" class="notice"><b>Теги</b> вводить через <b>пробел</b> или <b>запятую!</b></div>
		</div>
	</td>
</tr>
<tr>
	<td class="row1 vTop pad_4" valign="top">
		<p><b>{L_OPTIONS}</b></p>
	</td>
	<td class="row2">
		<table class="bordered w100" cellpadding="0" border=0>
			<tr>
				<td>
					<p><b>Закрыть новость от комментирования?</b></p>
				</td>
				<td>
					<input type="radio" name="lock" value="1" {ACTIVE} />{L_YES} &nbsp;&nbsp;<input type="radio" name="lock" value="0" {NOT_ACTIVE} /> {L_NO}
				</td>
			</tr>
			<tr>
				<td>
					<p><b>Для кого отображать?</b></p>
				</td>
				<!-- BEGIN auth -->
					<td>{auth.S_AUTH_LEVELS_SELECT}</td>
				<!-- END auth -->
			</tr>
		</table>
	</td>
</tr>

</table>

</form>
